
date()

set.seed(5)

path<-getwd()

library("lattice")

library("boot")

library("coda")

# library("rjags")

# library("R2WinBUGS")

library("dclone")

library("stats")

library("nlme")

library("MASS")

library("splines")

library("xtable")

# load.module("glm")

# library("VGAMdata")

# library("fpc")

# library("pvclust")

# library("psych")



# setwd("Dropbox/Small Area + Clustering/NHANES")

####   setwd(NHANES)


DEMO_G<-read.csv("DEMO_G.csv")

BMX_G<-read.csv("BMX_G.csv")



Res.seqn<-BMX_G$SEQN

Res.BMI<-BMX_G$BMXBMI

t1<-which(!is.na(Res.BMI))

Res.cir.waist<-BMX_G$BMXWAIST

t2<-which(!is.na(Res.cir.waist))

Res.age<-DEMO_G$RIDAGEYR

t3<-which(!is.na(Res.age) & Res.age>=20)

Res.gender<-DEMO_G$RIAGENDR

t4<-which(!is.na(Res.gender))

Res.race.hispanic<-DEMO_G$RIDRETH3

t5<-which(!is.na(Res.race.hispanic))

Res.poverty<-DEMO_G$INDFMPIR

t6<-which(!is.na(Res.poverty))

Res.edu<-DEMO_G$DMDEDUC2

t7<-which(!is.na(Res.edu))



t<-t5 %in% t7

index<-t5[t]

t<-t2 %in% index

index<-t2[t]

t<-t1 %in% index

index<-t1[t]

t<-t6 %in% index

index<-t6[t]

t<-t3 %in% index

index<-t3[t]

t<-t4 %in% index

index<-t4[t]

bmi<-Res.BMI[index]

age<-Res.age[index]

cir.waist<-Res.cir.waist[index]

race.hispanic<-Res.race.hispanic[index]

poverty<-Res.poverty[index]

education<-Res.edu[index]

## 1: Mexican

## 2: other hispanic

## 3: non-hispanic white

## 4: non-hispanic black

## 6: non-hispanic Asian

## 7: Other race - including multi racial 

# seqn<-Res.seqn[index]

gender<-Res.gender[index]



model<-lm(cir.waist~bmi)

beta.estimate.unit.level<-model$coefficients

q<-quantile(age, prob = seq(0, 1, length = 11), type = 5)

q.po<-quantile(poverty)

sigma_u<-c(0.36, 2.87, 4.05, 1.76, 11.40, 420.77, 36.17)


covariate.matrix.unit.level<-matrix(c(rep(1, length(bmi)), bmi), nrow=length(bmi), ncol=2, byrow= F)

area<-NULL

n.areas<-NULL

t<-1

for(i in 2:11){
	
	for(j in 1:2){
		
	    for(k in 1:7){
	    	
	    	for (l in 2: 5){
	    		
	    		for(u in 1:9){
	    			
	    			if(u!=6 & u!=7 & u!=8){
	    		
	    		         if(k!=5){
	    			
	    			if(i==2){
	    				
	    				if(l==2){
	    				
	    				     A<-which(age<q[i] & gender==j & race.hispanic==k & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1
	    				 
	    				}
	    				
	    				if(l>2 & l<5){
	    					
	    					 A<-which(age<q[i] & gender==j & race.hispanic==k & poverty>=q.po[l-1] & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A) 
	    				     
	    				     t<-t+1
	    					
	    					
	    				}
	    				
	    				if(l==5){
	    					
	    					A<-which(age<q[i] & gender==j & race.hispanic==k & poverty>=q.po[4] & poverty<=q.po[5] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1 
	    					
	    					
	    				}
	    				
	    				
	    			}
	    			
	    			
	    			if(i>2 & i<11){
	    				
	    				if(l==2){
	    				
	    				     A<-which(age>=q[i-1] & age<q[i] & gender==j & race.hispanic==k & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1

	    				 
	    				}
	    				
	    				if(l>2 & l<5){
	    					
	    					 A<-which(age>=q[i-1] & age<q[i] & gender==j & race.hispanic==k & poverty>=q.po[l-1] & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1
 
	    					
	    					
	    				}
	    				
	    				if(l==5){
	    					
	    					A<-which(age>=q[i-1] & age<q[i] & gender==j & race.hispanic==k & poverty>=q.po[4] & poverty<=q.po[5] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A) 
	    				     
	    				     t<-t+1
	    					
	    					
	    				}
	    				
	    				
	    			}
	    			
	    			if(i==11){
	    				
	    				if(l==2){
	    				
	    				     A<-which(age>=q[10] & age<=q[11] & gender==j & race.hispanic==k & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1

	    				 
	    				}
	    				
	    				if(l>2 & l<5){
	    					
	    					 A<-which(age>=q[10] & age<=q[11] & gender==j & race.hispanic==k & poverty>=q.po[l-1] & poverty<q.po[l] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1 
	    					
	    					
	    				}
	    				
	    				if(l==5){
	    					
	    					A<-which(age>=q[10] & age<=q[11] & gender==j & race.hispanic==k & poverty>=q.po[4] & poverty<=q.po[5] & education==u)
	    				 
	    				     n.areas[t]<-length(A)
	    				     
	    				     area<-c(area, A)
	    				     
	    				     t<-t+1 
	    					
	    					
	    				}
	    				
	    				}
	    			}
	    			
	    			
	    		}
	    		
	    	}
	    }
	    
	   }  
	}
	
	
}


total.no.areas<-t-1

t<-which(n.areas==0)

n.areas<-n.areas[-t]




Rep<-5000

no.row<-length(n.areas)

co.second.column<-NULL

counter<-NULL



variance.inside.areas<-NULL

for(i in 1: no.row){
	
	
	
	if(i==1){
		
		A<-area[1:n.areas[i]]
		
		co.second.column[i]<-mean(bmi[A])
		
		# Y[i]<-mean(cir.waist[A])
		
		model<-lm(cir.waist[A]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i]<-sum((cir.waist[A]-mean(cir.waist[A]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i]<=0 || is.na(variance.inside.areas[i])) variance.inside.areas[i]<-sum((cir.waist-mean(cir.waist))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     
		     if(!(variance.inside.areas[i]<=0 || is.na(variance.inside.areas[i])))
		        
		          counter<-c(counter, i)
		          
   		}
		
		
		if(n.areas[i]==1) variance.inside.areas[i]<-sum((cir.waist-mean(cir.waist))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		
		
		
			}
	
	if(i>1){
		
		a<-sum(n.areas[1:(i-1)])+1
		
		b<-sum(n.areas[1:i])
		
		A<-area[a:b]
		
		co.second.column[i]<-mean(bmi[A])
		
		# Y[i]<-mean(cir.waist[A])
		
		model<-lm(cir.waist[A]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i]<-sum((cir.waist[A]-mean(cir.waist[A]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i]<=0 || is.na(variance.inside.areas[i])) variance.inside.areas[i]<-sum((cir.waist-mean(cir.waist))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     
		      if(!(variance.inside.areas[i]<=0 || is.na(variance.inside.areas[i])))
		        
		          counter<-c(counter, i)


		}
		
		### 843 small areas have valid estimate of sampling variance following this approach.
		
		
		if(n.areas[i]==1) variance.inside.areas[i]<-sum((cir.waist-mean(cir.waist))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
						
						
		###  519 small areas have number of samples 1! 				
		
	}
	
 	
}

one<-rep(1, no.row)

covariate.matrix<-matrix(c(one, co.second.column), nrow=no.row, ncol=2, byrow=F)

cluster.number<-7

d<-dist(covariate.matrix[,2])

hc<-hclust(d, method="complete")

plot(hc)

rect.hclust(hc, cluster.number)

n_c<-NULL


memb<-cluster.summary<- cutree(hc, k = cluster.number)

clusters.element<-NULL

for(i in 1:cluster.number){
	
	B<-which(memb==i)
	
	clusters.element<-c(clusters.element, B)
	
	n_c[i]<-length(B)
	
}

cluster.ordered<-clusters.element

n<-NULL


n[1]<-sum(n_c)


sigma_e<-variance.inside.areas

D<-variance.inside.areas/n.areas

D<-matrix(D, nrow=no.row, ncol=1)

Y<-matrix(0, nrow=sum(n.areas), ncol=Rep)

theta<-matrix(0, nrow=sum(n.areas), ncol=Rep)

sampling.error<-matrix(0, nrow=sum(n.areas), ncol=Rep)

variance.inside.areas<-matrix(0, nrow=no.row, ncol=Rep)

variance.area.level<-matrix(0, nrow=no.row, ncol=Rep)

second.term<-matrix(0, nrow=no.row, ncol=Rep)

for(g in 1: Rep){

sigma.prime<-NULL

# sigma<-NULL



for(i in 1:cluster.number)
{
	
	    cluster<-which(cluster.summary==i)		
		
		for(k in 1: length(cluster)){


	    if(cluster[k]==1){
		
		A<-area[1:n.areas[cluster[k]]]
				
		model<-lm(cir.waist[A]~bmi[A])

        beta.estimate<-model$coefficients
        
        if(!(is.na(beta.estimate[2])))
        {
        	
        	mu<-bmi[A] * beta.estimate[2] +1
        	
         }
           
		if(is.na(beta.estimate[2])){
			
			mu<-bmi[A] * beta.estimate.unit.level[2] +1
			
		}
		
		
		
			}
	
	    if(cluster[k]>1){
		
		a<-sum(n.areas[1:(cluster[k]-1)])+1
		
		b<-sum(n.areas[1:cluster[k]])
		
		A<-area[a:b]
		
		model<-lm(cir.waist[A]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(!(is.na(beta.estimate[2])))
        {
        	
            mu<-bmi[A] * beta.estimate[2] +1
            
        }
           
		if(is.na(beta.estimate[2])){
			
			mu<-bmi[A] * beta.estimate.unit.level[2] +1
			
		}
		
		
		
		
	}
			
		     var<-diag(sigma_u[i], nrow=n.areas[cluster[k]])
		     
		     theta[A,g]<-mvrnorm(1, mu, var)
		     
		     sigma.star<-diag(sigma_e[cluster[k]], , nrow=n.areas[cluster[k]])
				
			 Y[A,g]<-mvrnorm(1, theta[A,g], sigma.star)
			
			 sampling.error[A, g]<-Y[A,g]-theta[A,g]
				
			}
			
			
			
			
	}

beta.estimate.unit.level<-lm(Y[, g]~bmi)$coefficients


for(i in 1: no.row){
	
	
	
	if(i==1){
		
		A<-area[1:n.areas[i]]
				
		model<-lm(Y[A, g]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i, g]<-sum((Y[A, g]-mean(Y[A, g]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i, g]<=0 || is.na(variance.inside.areas[i, g])) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     
		          
   		}
		
		
		if(n.areas[i]==1) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		
		
		
			}
	
	if(i>1){
		
		a<-sum(n.areas[1:(i-1)])+1
		
		b<-sum(n.areas[1:i])
		
		A<-area[a:b]
		
		model<-lm(Y[A, g]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i, g]<-sum((Y[A, g]-mean(Y[A, g]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i, g]<=0 || is.na(variance.inside.areas[i, g])) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     

		}
		
		
		if(n.areas[i]==1) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
						
		
	}
	
 	
}




for(i in 1: no.row){
	
	
	
	if(i==1){
		
		A<-area[1:n.areas[i]]
				
		model<-lm(Y[A, g]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i, g]<-sum((Y[A, g]-mean(Y[A, g]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i, g]<=0 || is.na(variance.inside.areas[i, g])) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     
		          
   		}
		
		
		if(n.areas[i]==1) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		
		
		
			}
	
	if(i>1){
		
		a<-sum(n.areas[1:(i-1)])+1
		
		b<-sum(n.areas[1:i])
		
		A<-area[a:b]
		
		second.term[i, g]<-(sum((sampling.error[A, g]-mean(sampling.error[A, g])))*(sum((bmi[A]-mean(bmi[A])))))/(n.areas[i]-1)
		
		model<-lm(Y[A, g]~bmi[A])

        beta.estimate<-model$coefficients
		
		if(n.areas[i]>1)
		{
			 variance.inside.areas[i, g]<-sum((Y[A, g]-mean(Y[A, g]))^2)/(n.areas[i]-1)-(beta.estimate[2]^2)*sum((bmi[A]-mean(bmi[A]))^2)/(n.areas[i]-1)
		
		     if(variance.inside.areas[i, g]<=0 || is.na(variance.inside.areas[i, g])) variance.inside.areas[i]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
		     

		}
		
		
		if(n.areas[i]==1) variance.inside.areas[i, g]<-sum((Y[, g]-mean(Y[, g]))^2)/(sum(n.areas)-1)-(beta.estimate.unit.level[2]^2)*sum((bmi-mean(bmi))^2)/(sum(n.areas)-1)
						
		
	}
	
 	
}


variance.area.level[, g]<-variance.inside.areas[, g]/n.areas


}
      

     variance.area.level<-variance.area.level[counter, ]
     
     second.term<-second.term[counter, ]
     
     estimated.D<-NULL
     
     estimated.second.term<-NULL
     
     for(i in 1:length(counter)){
     	
     	
     	estimated.D[i]<-mean(variance.area.level[i, ])
     	
     	estimated.second.term[i]<-mean(second.term[i, ])
     	
     }


        D.counter<-D[counter]


plot(estimated.D, sigma_e, xlab="Estimated Values", ylab="True Values")



save(list = ls(all=TRUE), file = ".RData")

date        
                    



