            path<-getwd()
			library("boot")
			library("lattice")
			library("parallel")
			library("coda")
			# library("rbugs")
			# library("rjags")
			# library("R2WinBUGS")
			# library("dclone")
			#library("cluster")
			library("nlme")
			library("MASS")
			library("xtable")
			#library(Rlab)
			#library(rv)
			# load.module("glm")


areas<-268

Rep<-8000

agg.var.com.reml.mse<-matrix(0, ncol=10, nrow=Rep)

agg.var.com.mm.mse<-matrix(0, ncol=10, nrow=Rep)

agg.mse.simplest.real<-matrix(0, nrow=areas, ncol=Rep)

agg.mse.direct.real<-matrix(0, nrow=areas, ncol=Rep)

agg.mse.combined.real<-matrix(0, nrow=areas, ncol=Rep)

agg.mse.complete.clusters.real<-matrix(0, nrow=areas, ncol=Rep)

agg_g_3_simplest<-agg_g_3_combined<-agg_g_3_complete<-matrix(0, nrow=areas, ncol=Rep)


agg.MSE.simplest<-matrix(0, nrow=areas, ncol=Rep)

agg.MSE.direct<-matrix(0, nrow=areas, ncol=Rep)

agg.MSE.combined<-matrix(0, nrow=areas, ncol=Rep)

agg.MSE.complete.clusters<-matrix(0, nrow=areas, ncol=Rep)


mean.mse.simplest<-matrix(0, nrow=areas, ncol=1)

mean.mse.direct<-matrix(0, nrow=areas, ncol=1)

mean.mse.combined<-matrix(0, nrow=areas, ncol=1)

mean.mse.complete.clusters<-matrix(0, nrow=areas, ncol=1)


mean.MSE.simplest<-matrix(0, nrow=areas, ncol=1)

mean.MSE.direct<-matrix(0, nrow=areas, ncol=1)

mean.MSE.combined<-matrix(0, nrow=areas, ncol=1)

mean.MSE.complete.clusters<-matrix(0, nrow=areas, ncol=1)





agg.l<-0

tracking.counter<-1


for(f in 1:50){
  
  # if(f!=4){

   path<-paste("/home/torkashe/scratch/",f,"/",sep="")
   load(file=paste(path,".RData",sep=""))


   print("tracking.counter")

   print(tracking.counter)

   l<-end-begin

   # agg.var.com.reml.mse[tracking.counter:(tracking.counter+l), ]<-var.com.reml.mse[begin:end, ]

   # agg.var.com.mm.mse[tracking.counter:(tracking.counter+l), ]<-var.com.mm.mse[begin:end, ]

   
   agg.mse.simplest.real[, tracking.counter:(tracking.counter+l)]<-mse.simplest.real[, begin:end]

   agg.mse.direct.real[, tracking.counter:(tracking.counter+l)]<-mse.direct.real[, begin:end]

   agg.mse.combined.real[, tracking.counter:(tracking.counter+l)]<-mse.combined.real[, begin:end]

   agg.mse.complete.clusters.real[, tracking.counter:(tracking.counter+l)]<-mse.complete.clusters.real[, begin:end]


   agg.MSE.simplest[, tracking.counter:(tracking.counter+l)]<-MSE.simplest[, begin:end]

   agg.MSE.direct[, tracking.counter:(tracking.counter+l)]<-MSE.direct[, begin:end]

   agg.MSE.combined[, tracking.counter:(tracking.counter+l)]<-MSE.combined[, begin:end]

   agg.MSE.complete.clusters[, tracking.counter:(tracking.counter+l)]<-MSE.complete.clusters[, begin:end]

   agg_g_3_simplest[, tracking.counter:(tracking.counter+l)]<-g_3_simplest[, begin:end]

   agg_g_3_combined[, tracking.counter:(tracking.counter+l)]<-g_3_combined[, begin:end]

   agg_g_3_complete[, tracking.counter:(tracking.counter+l)]<-g_3_complete[, begin:end]




   tracking.counter<-tracking.counter+(end-begin)+1

   print("tracking.counter")

   print(tracking.counter)



cat(f)

 #}


}

tracking.counter<-tracking.counter-1

G_3_simplest<-G_3_combined<-G_3_complete<-matrix(0, nrow=areas, ncol=1)

mean.var.com.reml.mse<-matrix(0, nrow=10, ncol=1)

mean.var.com.mm.mse<-matrix(0, nrow=10, ncol=1)

# for(i in 1: 10){

# mean.var.com.reml.mse[i]<-mean(agg.var.com.reml.mse[, i])

# mean.var.com.mm.mse[i]<-mean(agg.var.com.mm.mse[, i])

# }


# mse.sigma<-c(mean.var.com.reml.mse, mean.var.com.mm.mse)

# mse.sigma<-matrix(mse.sigma, nrow=2, ncol=10, byrow=T)

# xtable(mse.sigma)

print("sigma_u")
print(sigma_u)



var.MSE.simplest<-var.MSE.direct<-var.MSE.combined<-var.MSE.complete.clusters<-NULL


for(i in 1: areas){

   
    var.MSE.simplest[i]<-var(agg.MSE.simplest[i, 1:tracking.counter])

    var.MSE.direct[i]<-var(agg.MSE.direct[i, 1:tracking.counter])

    var.MSE.combined[i]<-var(agg.MSE.combined[i, 1:tracking.counter])

    var.MSE.complete.clusters[i]<-var(agg.MSE.complete.clusters[i, 1:tracking.counter])



}

var.MSE.simplest.quantile<-quantile(var.MSE.simplest, prob = seq(0, 1, length = 11), type = 5)


var.MSE.simplest.table<-c(var.MSE.simplest.quantile, mean(var.MSE.simplest.quantile))


var.MSE.combined.quantile<-quantile(var.MSE.combined, prob = seq(0, 1, length = 11), type = 5)


var.MSE.combined.table<-c(var.MSE.combined.quantile, mean(var.MSE.combined.quantile))


var.MSE.complete.clusters.quantile<-quantile(var.MSE.complete.clusters, prob = seq(0, 1, length = 11), type = 5)


var.MSE.complete.clusters.table<-c(var.MSE.complete.clusters.quantile, mean(var.MSE.combined.quantile))


var.table.MSE<-matrix(c(var.MSE.complete.clusters.table, var.MSE.combined.table, var.MSE.simplest.table), nrow=12, ncol=3, byrow= FALSE)


xtable(var.table.MSE)






for(i in 1: areas){


    mean.mse.simplest[i]<-mean(agg.mse.simplest.real[i, 1:tracking.counter])

    mean.mse.direct[i]<-mean(agg.mse.direct.real[i, 1:tracking.counter])

    mean.mse.combined[i]<-mean(agg.mse.combined.real[i, 1:tracking.counter])

    mean.mse.complete.clusters[i]<-mean(agg.mse.complete.clusters.real[i, 1:tracking.counter])


   
    mean.MSE.simplest[i]<-mean(agg.MSE.simplest[i, 1:tracking.counter])

    mean.MSE.direct[i]<-mean(agg.MSE.direct[i, 1:tracking.counter])

    mean.MSE.combined[i]<-mean(agg.MSE.combined[i, 1:tracking.counter])

    mean.MSE.complete.clusters[i]<-mean(agg.MSE.complete.clusters[i, 1:tracking.counter])

    G_3_simplest[i]<-mean(agg_g_3_simplest[i, ])

    G_3_combined[i]<-mean(agg_g_3_combined[i, ])

    G_3_complete[i]<-mean(agg_g_3_complete[i, ])



}


cv.MSE.simplest<-cv.MSE.direct<-cv.MSE.combined<-cv.MSE.complete.clusters<-NULL


for(i in 1: areas){

   
    cv.MSE.simplest[i]<-sd(agg.MSE.simplest[i, 1:tracking.counter])/mean(agg.MSE.simplest[i, 1:tracking.counter])

    cv.MSE.direct[i]<-sd(agg.MSE.direct[i, 1:tracking.counter])/mean(agg.MSE.direct[i, 1:tracking.counter])

    cv.MSE.combined[i]<-sd(agg.MSE.combined[i, 1:tracking.counter])/mean(agg.MSE.combined[i, 1:tracking.counter])

    cv.MSE.complete.clusters[i]<-sd(agg.MSE.complete.clusters[i, 1:tracking.counter])/mean(agg.MSE.complete.clusters[i, 1:tracking.counter])



}

cv.MSE.simplest.quantile<-quantile(cv.MSE.simplest, prob = seq(0, 1, length = 11), type = 5)


cv.MSE.simplest.table<-c(cv.MSE.simplest.quantile, mean(cv.MSE.simplest.quantile))


cv.MSE.combined.quantile<-quantile(cv.MSE.combined, prob = seq(0, 1, length = 11), type = 5)


cv.MSE.combined.table<-c(cv.MSE.combined.quantile, mean(cv.MSE.combined.quantile))


cv.MSE.complete.clusters.quantile<-quantile(cv.MSE.complete.clusters, prob = seq(0, 1, length = 11), type = 5)


cv.MSE.complete.clusters.table<-c(cv.MSE.complete.clusters.quantile, mean(cv.MSE.combined.quantile))


cv.table.MSE<-matrix(c(cv.MSE.complete.clusters.table, cv.MSE.combined.table, cv.MSE.simplest.table), nrow=12, ncol=3, byrow= FALSE)


xtable(cv.table.MSE)








#######    Is g_3 bigger for combined compared to the simple method?

print(sum(G_3_combined>=G_3_simplest)/length(G_3_simplest))


#######    Is g_3 bigger for complete compared to the simple method?

print(sum(G_3_complete>=G_3_simplest)/length(G_3_simplest))






# simplest.over.direct<-quantile(mean.MSE.simplest/mean.MSE.direct, prob = seq(0, 1, length = 11), type = 5)

# simplest.over.direct.table<-c(simplest.over.direct, mean(mean.MSE.simplest/mean.MSE.direct))




# complete.over.direct<-quantile(mean.MSE.complete.clusters/mean.MSE.direct, prob = seq(0, 1, length = 11), type = 5)

# complete.over.direct.table<-c(complete.over.direct, mean(mean.MSE.complete.clusters/mean.MSE.direct))




# combined.over.direct<-quantile(mean.MSE.combined/mean.MSE.direct, prob = seq(0, 1, length = 11), type = 5)

# combined.over.direct.table<-c(combined.over.direct, mean(mean.MSE.combined/mean.MSE.direct))


# print("mean.MSE.combined")

# print(mean.MSE.combined)


# print("mean.MSE.simplest")

# print(mean.MSE.simplest)


# print("mean.MSE.direct")

# print(mean.MSE.direct)


complete.over.simplest.table<-mean.MSE.simplest/mean.MSE.complete.clusters


complete.over.simplest.table<-c(complete.over.simplest, mean(mean.MSE.simplest/mean.MSE.complete.clusters))


combined.over.simple<-quantile(mean.MSE.simplest/mean.MSE.combined, prob = seq(0, 1, length = 11), type = 5)


combined.over.simple.table<-c(combined.over.simple, mean(mean.MSE.simplest/mean.MSE.combined))


complete.over.combined<-quantile(mean.MSE.combined/mean.MSE.complete.clusters, prob = seq(0, 1, length = 11), type = 5)


complete.over.combined.table<-c(complete.over.combined, mean(mean.MSE.combined/mean.MSE.complete.clusters))

# mspe.improvement.table<-matrix(c(simplest.over.direct.table, combined.over.direct.table, complete.over.direct), nrow=12, ncol=3, byrow= FALSE)


mspe.improvement.table.MSPE<-matrix(c(complete.over.simplest.table, combined.over.simple.table, complete.over.combined.table), nrow=12, ncol=3, byrow= FALSE)


xtable(mspe.improvement.table.MSPE)

# print("MSPE approximation improvement table")

# print(mspe.improvement.table)




##########################################################################################
##########################################################################################
###################################  EMSPE  ##############################################

complete.over.simplest.table<-mean.mse.simplest/mean.mse.complete.clusters


complete.over.simplest.table<-c(complete.over.simplest, mean(mean.mse.simplest/mean.mse.complete.clusters))


combined.over.simple<-quantile(mean.mse.simplest/mean.mse.combined, prob = seq(0, 1, length = 11), type = 5)


combined.over.simple.table<-c(combined.over.simple, mean(mean.mse.simplest/mean.mse.combined))


complete.over.combined<-quantile(mean.mse.combined/mean.mse.complete.clusters, prob = seq(0, 1, length = 11), type = 5)


complete.over.combined.table<-c(complete.over.combined, mean(mean.mse.combined/mean.mse.complete.clusters))

# mspe.improvement.table<-matrix(c(simplest.over.direct.table, combined.over.direct.table, complete.over.direct), nrow=12, ncol=3, byrow= FALSE)


mspe.improvement.table.EMSPE<-matrix(c(complete.over.simplest.table, combined.over.simple.table, complete.over.combined.table), nrow=12, ncol=3, byrow= FALSE)


xtable(mspe.improvement.table.EMSPE)

# print("EMSPE approximation improvement table")

# print(mspe.improvement.table)







### x.max<-max(c(mean.mse.direct, mean.mse.simplest, mean.mse.combined, mean.mse.complete.clusters, mean.MSE.direct, mean.MSE.simplest, mean.MSE.combined, mean.MSE.complete.clusters))


### x.min<-min(c(mean.mse.direct, mean.mse.simplest, mean.mse.combined, mean.mse.complete.clusters, mean.MSE.direct, mean.MSE.simplest, mean.MSE.combined, mean.MSE.complete.clusters))


x.max<-max(c(mean.mse.simplest, mean.mse.combined, mean.mse.complete.clusters, mean.MSE.simplest, mean.MSE.combined, mean.MSE.complete.clusters))


x.min<-min(c(mean.mse.simplest, mean.mse.combined, mean.mse.complete.clusters, mean.MSE.simplest, mean.MSE.combined, mean.MSE.complete.clusters))

b<-(x.max-x.min)/20

breaks.hist<-seq(x.min, x.max, b)


# quartz(height=8,width=5,type="png")

# png(file="hist-EMSPE-clustering.png",width=1400,height=600)

op<-par(mfrow=c(3, 1), mgp=c(3, 1.3, 0), mar=c(5,5,2,1), family="Times", cex.lab=3,cex=1, cex.axis=4, lwd=3)

# hist(mean.mse.direct, breaks=breaks.hist   , xlab="(a)",  main=" ", cex.lab=2, cex.axis=2.5, cex=3, ylab=" ", lwd=4, mgp=c(4, 1.5, 0), mar=c(5,5,2,1), family="Times")

hist(mean.mse.simplest, breaks=breaks.hist   , xlab="(a)",  main=" ", cex.lab=2, cex.axis=2.5, cex=3, ylab=" ",ylim=c(0, 35), lwd=4, mgp=c(4, 1.5, 0), mar=c(5,5,2,1), family="Times")


hist(mean.mse.combined, breaks=breaks.hist  , xlab="(b)", main=" ", cex.lab=2, cex.axis=2.5, cex=3, ylab=" ", lwd=4, ylim=c(0, 35), mgp=c(4, 1.5, 0), mar=c(5,5,2,1), family="Times")

hist(mean.mse.complete.clusters, breaks=breaks.hist  , xlab="(c)",  main=" ", cex.lab=2, cex.axis=2.5, cex=3, ylab=" ", lwd=4, ylim=c(0, 35), mgp=c(4, 1.5, 0), mar=c(5,5,2,1), family="Times")



dev.off()


# print("complete over simple")

# print(mean.mse.simplest/mean.mse.complete.clusters)


# print("combined over simple")

# print(mean.mse.simplest/mean.mse.combined)



complete.over.direct<-quantile(mean.mse.complete.clusters/mean.mse.direct, prob = seq(0, 1, length = 11), type = 5)


complete.over.direct.table<-c(complete.over.direct, mean(mean.mse.complete.clusters/mean.mse.direct))


combined.over.direct<-quantile(mean.mse.combined/mean.mse.direct, prob = seq(0, 1, length = 11), type = 5)


combined.over.direct.table<-c(combined.over.direct, mean(mean.mse.combined/mean.mse.direct))


simplest.over.direct<-quantile(mean.mse.simplest/mean.mse.direct, prob = seq(0, 1, length = 11), type = 5)


simplest.over.direct.table<-c(simplest.over.direct, mean(mean.mse.simplest/mean.mse.direct))


mspe.improvement.table<-matrix(c(simplest.over.direct.table, combined.over.direct.table, complete.over.direct.table), nrow=12, ncol=3, byrow= FALSE)


xtable(mspe.improvement.table)

print("mspe.improvement.table")

print(mspe.improvement.table)


rb.complete<-mean.MSE.complete.clusters/mean.mse.complete.clusters-1

rb.combined<-mean.MSE.combined/mean.mse.combined-1

rb.simple<-mean.MSE.simplest/mean.mse.simplest-1



rb.complete.table<-c(quantile(rb.complete, prob = seq(0, 1, length = 11), type = 5), mean(rb.complete))

rb.combined.table<-c(quantile(rb.combined, prob = seq(0, 1, length = 11), type = 5), mean(rb.combined))

rb.simple.table<-c(quantile(rb.simple, prob = seq(0, 1, length = 11), type = 5), mean(rb.simple))


rb<-c(rb.complete.table, rb.combined.table, rb.simple.table)

rb<-matrix(rb, nrow=12, ncol=3, byrow=FALSE)

xtable(rb)




print("rb.complete.table")

print(rb.complete.table)


print("rb.combined.table")

print(rb.combined.table)


print("rb.simple.table")

print(rb.simple.table)


# print("rb")

# print(rb)



save(list = ls(all=TRUE), file = ".RData")

date